package cn.teammodel.model.entity.common;

import cn.teammodel.model.entity.BaseItem;
import com.azure.spring.data.cosmos.core.mapping.Container;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

@EqualsAndHashCode(callSuper = true)
@Container(containerName = "Common")
@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ExamClassResult extends BaseItem {
    public String school;
    public String examId ;
    public String subjectId ;
    public String gradeId ;
    public int year ;
    public ClassInfo info ;
    public boolean progress;
    public List<String> studentIds ;
    public List<List<String>> studentAnswers ;
    //记录学生客观题选项内容，便于学情分析
    public List<List<List<String>>> ans ;
    public List<List<Double>> studentScores ;
    //记录学生作答状态
    //0 已作答 1缺考 2补考 3补考完成
    public List<Integer> status ;
    public String scope ;
    public List<Double> sum ;
    public double average ;
    //单科单班得分率
    public double srate ;
    //单科单班标准差
    public double standard ;

    @Data
    public static class ClassInfo {
        public String id;
        public String name;
        public String periodId ;
        public int year ;
        public String no;
    }
}

